<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
<head>
  <meta charset="utf-8" />
  <meta name="generator" content="pandoc" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes" />
  <title>Cacti – Documentation Standards</title>
  <style type="text/css">
      code{white-space: pre-wrap;}
      span.smallcaps{font-variant: small-caps;}
      span.underline{text-decoration: underline;}
      div.column{display: inline-block; vertical-align: top; width: 50%;}
  </style>
  <style type="text/css">
a.sourceLine { display: inline-block; line-height: 1.25; }
a.sourceLine { pointer-events: none; color: inherit; text-decoration: inherit; }
a.sourceLine:empty { height: 1.2em; }
.sourceCode { overflow: visible; }
code.sourceCode { white-space: pre; position: relative; }
div.sourceCode { margin: 1em 0; }
pre.sourceCode { margin: 0; }
@media screen {
div.sourceCode { overflow: auto; }
}
@media print {
code.sourceCode { white-space: pre-wrap; }
a.sourceLine { text-indent: -1em; padding-left: 1em; }
}
pre.numberSource a.sourceLine
  { position: relative; left: -4em; }
pre.numberSource a.sourceLine::before
  { content: attr(title);
    position: relative; left: -1em; text-align: right; vertical-align: baseline;
    border: none; pointer-events: all; display: inline-block;
    -webkit-touch-callout: none; -webkit-user-select: none;
    -khtml-user-select: none; -moz-user-select: none;
    -ms-user-select: none; user-select: none;
    padding: 0 4px; width: 4em;
    color: #aaaaaa;
  }
pre.numberSource { margin-left: 3em; border-left: 1px solid #aaaaaa;  padding-left: 4px; }
div.sourceCode
  {  }
@media screen {
a.sourceLine::before { text-decoration: underline; }
}
code span.al { color: #ff0000; font-weight: bold; } /* Alert */
code span.an { color: #60a0b0; font-weight: bold; font-style: italic; } /* Annotation */
code span.at { color: #7d9029; } /* Attribute */
code span.bn { color: #40a070; } /* BaseN */
code span.bu { } /* BuiltIn */
code span.cf { color: #007020; font-weight: bold; } /* ControlFlow */
code span.ch { color: #4070a0; } /* Char */
code span.cn { color: #880000; } /* Constant */
code span.co { color: #60a0b0; font-style: italic; } /* Comment */
code span.cv { color: #60a0b0; font-weight: bold; font-style: italic; } /* CommentVar */
code span.do { color: #ba2121; font-style: italic; } /* Documentation */
code span.dt { color: #902000; } /* DataType */
code span.dv { color: #40a070; } /* DecVal */
code span.er { color: #ff0000; font-weight: bold; } /* Error */
code span.ex { } /* Extension */
code span.fl { color: #40a070; } /* Float */
code span.fu { color: #06287e; } /* Function */
code span.im { } /* Import */
code span.in { color: #60a0b0; font-weight: bold; font-style: italic; } /* Information */
code span.kw { color: #007020; font-weight: bold; } /* Keyword */
code span.op { color: #666666; } /* Operator */
code span.ot { color: #007020; } /* Other */
code span.pp { color: #bc7a00; } /* Preprocessor */
code span.sc { color: #4070a0; } /* SpecialChar */
code span.ss { color: #bb6688; } /* SpecialString */
code span.st { color: #4070a0; } /* String */
code span.va { color: #19177c; } /* Variable */
code span.vs { color: #4070a0; } /* VerbatimString */
code span.wa { color: #60a0b0; font-weight: bold; font-style: italic; } /* Warning */
  </style>
  <link rel="stylesheet" href="Cacti-Github.css" />
</head>
<body>
<h1 id="documentation-standards">Documentation Standards</h1>
<h2 id="introduction">Introduction</h2>
<p>The following are the standards to be used by Cacti Group members and Contributes when maintaining the documentation of Cacti or any of its plugins. These standards have also been applied to the Travis CI checker on GitHub.</p>
<h2 id="reporting-corrections--omissions">Reporting corrections / omissions</h2>
<p>Please report any errors or corrections on the Cacti Documentation GitHub repository which is located at <a href="https://github.com/cacti/documentation/">https://github.com/cacti/documentation/</a> where all changes can be tracked. Any <strong>Pull Requests</strong> will be welcome to help speed up changes by allowing the Cacti Group to simply verify the changes are correct before submitting them.</p>
<h2 id="copyright">Copyright</h2>
<p>All documentation should be marked as copyright to the Cacti Group. This is done by simply adding the following text to the bottom of the page (including the blank line):</p>
<div class="sourceCode" id="cb1"><pre class="sourceCode markdown"><code class="sourceCode markdown"><a class="sourceLine" id="cb1-1" title="1"></a>
<a class="sourceLine" id="cb1-2" title="2">---</a>
<a class="sourceLine" id="cb1-3" title="3">&lt;copy&gt;Copyright (c) 2004-2021 The Cacti Group&lt;/copy&gt;</a></code></pre></div>
<h2 id="titles">Titles</h2>
<h3 id="title-levels">Title Levels</h3>
<p>When creating documentation titles, they should:</p>
<ul>
<li><p>use the # symbol with 1 - 5 hashes</p>
<p><em>The actual count of hashes represents the sub-level of the title.</em></p></li>
<li><p>not have multiple level 1 headers</p>
<p><code>MD025 Multiple top level headers in the same document</code></p></li>
<li><p>not have punctuation at the end of the header</p>
<p><code>MD026 Trailing punctuation in header</code></p></li>
<li><p>not use <code>----</code> or <code>====</code> on a line that follows a header</p>
<p><code>MD003 Header style</code></p></li>
<li><p>increment down only one sub-level at a time</p>
<p><em>You may go back up any number of levels</em></p>
<div class="sourceCode" id="cb2"><pre class="sourceCode markdown"><code class="sourceCode markdown"><a class="sourceLine" id="cb2-1" title="1"></a>
<a class="sourceLine" id="cb2-2" title="2"><span class="fu"># Main Title 1</span></a>
<a class="sourceLine" id="cb2-3" title="3"><span class="fu">## Main Title 1.Sub Title 1</span></a>
<a class="sourceLine" id="cb2-4" title="4"><span class="fu">### Main Title 1.Sub Title 1.Sub Title 1</span></a>
<a class="sourceLine" id="cb2-5" title="5"><span class="fu">### Main Title 1.Sub Title 1.Sub Title 2</span></a>
<a class="sourceLine" id="cb2-6" title="6"><span class="fu">## Main Title 1.Sub Title 2</span></a>
<a class="sourceLine" id="cb2-7" title="7"><span class="fu">### Main Title 1.Sub Title 2.Sub Title 1</span></a>
<a class="sourceLine" id="cb2-8" title="8"><span class="fu">### Main Title 1.Sub Title 2.Sub Title 2</span></a>
<a class="sourceLine" id="cb2-9" title="9"><span class="fu"># Main Title 2</span></a>
<a class="sourceLine" id="cb2-10" title="10"><span class="fu">### Main Title 2.Invalid Sub Title 1.Invalid Sub Title 1</span></a>
<a class="sourceLine" id="cb2-11" title="11"></a></code></pre></div></li>
<li><p>not use other title definition symbols</p>
<p><em>Whilst they are valid markdown, they will result in style errors.</em></p></li>
</ul>
<p>Failure to follow this will result in an <code>MD001</code> error during Travis CI checks.</p>
<h6 id="example-1-incorrect-markdown-for-title-levels">Example 1. Incorrect Markdown for Title Levels</h6>
<div class="sourceCode" id="cb3"><pre class="sourceCode markdown"><code class="sourceCode markdown"><a class="sourceLine" id="cb3-1" title="1"></a>
<a class="sourceLine" id="cb3-2" title="2"><span class="fu"># Welcome</span></a>
<a class="sourceLine" id="cb3-3" title="3"></a>
<a class="sourceLine" id="cb3-4" title="4">Welcome to us</a>
<a class="sourceLine" id="cb3-5" title="5"></a>
<a class="sourceLine" id="cb3-6" title="6"><span class="fu">## Using the software 1.2</span></a>
<a class="sourceLine" id="cb3-7" title="7"></a>
<a class="sourceLine" id="cb3-8" title="8">To use most functions of our software, navigate the menus</a>
<a class="sourceLine" id="cb3-9" title="9"></a>
<a class="sourceLine" id="cb3-10" title="10"><span class="fu">#### Accessing the menus 1.2.1.1</span></a>
<a class="sourceLine" id="cb3-11" title="11"></a>
<a class="sourceLine" id="cb3-12" title="12">The menus are located at the top of the page ...</a>
<a class="sourceLine" id="cb3-13" title="13"></a></code></pre></div>
<h6 id="example-2-corrected-markdown-for-title-levels">Example 2. Corrected Markdown for Title Levels</h6>
<div class="sourceCode" id="cb4"><pre class="sourceCode markdown"><code class="sourceCode markdown"><a class="sourceLine" id="cb4-1" title="1"></a>
<a class="sourceLine" id="cb4-2" title="2"><span class="fu"># Welcome</span></a>
<a class="sourceLine" id="cb4-3" title="3"></a>
<a class="sourceLine" id="cb4-4" title="4">Welcome to us</a>
<a class="sourceLine" id="cb4-5" title="5"></a>
<a class="sourceLine" id="cb4-6" title="6"><span class="fu">## Using the software 1.2</span></a>
<a class="sourceLine" id="cb4-7" title="7"></a>
<a class="sourceLine" id="cb4-8" title="8">To use most functions of our software, navigate the menus</a>
<a class="sourceLine" id="cb4-9" title="9"></a>
<a class="sourceLine" id="cb4-10" title="10"><span class="fu">### Accessing the menus 1.2.1</span></a>
<a class="sourceLine" id="cb4-11" title="11"></a>
<a class="sourceLine" id="cb4-12" title="12">The menus are located at the top of the page ...</a>
<a class="sourceLine" id="cb4-13" title="13"></a></code></pre></div>
<h3 id="title-spacing">Title Spacing</h3>
<p>All titles should be separated with blank lines either side of the title. The only exception to this is if the title is on the first line of the page. They should also have a single space between the hash symbols and text.</p>
<h6 id="example-3-incorrect-markdown-for-title-spacing">Example 3. Incorrect Markdown for Title Spacing</h6>
<div class="sourceCode" id="cb5"><pre class="sourceCode markdown"><code class="sourceCode markdown"><a class="sourceLine" id="cb5-1" title="1"></a>
<a class="sourceLine" id="cb5-2" title="2"><span class="fu"># Welcome</span></a>
<a class="sourceLine" id="cb5-3" title="3">Welcome to us</a>
<a class="sourceLine" id="cb5-4" title="4"></a>
<a class="sourceLine" id="cb5-5" title="5"><span class="fu">## Using the software 1.2</span></a>
<a class="sourceLine" id="cb5-6" title="6">To use most functions of our software, navigate the menus</a>
<a class="sourceLine" id="cb5-7" title="7"><span class="fu">### Accessing the menus 1.2.1</span></a>
<a class="sourceLine" id="cb5-8" title="8">The menus are located at the top of the page ...</a>
<a class="sourceLine" id="cb5-9" title="9"></a></code></pre></div>
<h6 id="example-4-correct-markdown-for-title-spacing">Example 4. Correct Markdown for Title Spacing</h6>
<div class="sourceCode" id="cb6"><pre class="sourceCode markdown"><code class="sourceCode markdown"><a class="sourceLine" id="cb6-1" title="1"></a>
<a class="sourceLine" id="cb6-2" title="2"><span class="fu"># Welcome</span></a>
<a class="sourceLine" id="cb6-3" title="3"></a>
<a class="sourceLine" id="cb6-4" title="4">Welcome to us</a>
<a class="sourceLine" id="cb6-5" title="5"></a>
<a class="sourceLine" id="cb6-6" title="6"><span class="fu">## Using the software 1.2</span></a>
<a class="sourceLine" id="cb6-7" title="7"></a>
<a class="sourceLine" id="cb6-8" title="8">To use most functions of our software, navigate the menus</a>
<a class="sourceLine" id="cb6-9" title="9"></a>
<a class="sourceLine" id="cb6-10" title="10"><span class="fu">### Accessing the menus 1.2.1</span></a>
<a class="sourceLine" id="cb6-11" title="11"></a>
<a class="sourceLine" id="cb6-12" title="12">The menus are located at the top of the page ...</a>
<a class="sourceLine" id="cb6-13" title="13"></a></code></pre></div>
<h3 id="titles-for-captions">Titles for Captions</h3>
<p>Titles for examples, images and tables are the only exception to the Title Level rule. These are normally set to 6 (Six) hash symbols (e.g., <code>######</code>). The format of the text should be such that it reads the type of caption, a number, full stop, then the description</p>
<div class="sourceCode" id="cb7"><pre class="sourceCode markdown"><code class="sourceCode markdown"><a class="sourceLine" id="cb7-1" title="1"></a>
<a class="sourceLine" id="cb7-2" title="2"><span class="fu">###### &lt;caption type&gt; &lt;number&gt;. &lt;description&gt;</span></a>
<a class="sourceLine" id="cb7-3" title="3"></a></code></pre></div>
<h6 id="example-5-example-of-this-caption">Example 5. Example of this caption</h6>
<div class="sourceCode" id="cb8"><pre class="sourceCode markdown"><code class="sourceCode markdown"><a class="sourceLine" id="cb8-1" title="1"></a>
<a class="sourceLine" id="cb8-2" title="2"><span class="fu">###### Example 5. Example of this caption</span></a>
<a class="sourceLine" id="cb8-3" title="3"></a></code></pre></div>
<h2 id="text">Text</h2>
<h3 id="standard-text">Standard Text</h3>
<p>Any text written outside of code blocks must:</p>
<ul>
<li><p>be formatted such that it does not exceed 79 characters. This is to make it easier to read and adjust the paragraphs in any editor.</p>
<p><code>MD013 Line length</code></p></li>
<li><p>have blank lines between paragraphs</p></li>
<li><p>not have multiple blank lines</p>
<p><code>MD012 Multiple consecutive blank lines</code></p></li>
<li><p>not have trailing spaces</p>
<p><code>MD009 Trailing spaces</code></p></li>
<li><p>not use HTML outside of fenced code blocks</p>
<p><code>MD033 Inline HTML</code></p></li>
</ul>
<h3 id="tables">Tables</h3>
<p>All tables should have a caption applied to them in the style that was listed above.</p>
<h3 id="lists">Lists</h3>
<p>All lists should:</p>
<ul>
<li><p>use a single <code>-</code> (dash) character for bullet points</p></li>
<li><p>use the same indentation for the same level</p>
<p><code>MD005 Inconsistent indentation for list items at the same level</code></p></li>
<li><p>start at the beginning of a line (no spaces/indents) for the top level</p>
<p><code>MD006 Consider starting bulleted lists at the beginning of the line</code></p></li>
<li><p>use a digit following by a full stop for numbered lists</p></li>
<li><p>should have a single space between the list item marker and the start of the text</p></li>
<li><p>have blanks lines around items in the same fashion as titles</p>
<p><code>MD030 Spaces after list markers</code></p></li>
<li><p>wrap text with indentation as they are exempt from the text-width formatting rule</p>
<div class="sourceCode" id="cb9"><pre class="sourceCode markdown"><code class="sourceCode markdown"><a class="sourceLine" id="cb9-1" title="1">- <span class="fl">wrap text with indentation as they are exempt from the text-width</span></a>
<a class="sourceLine" id="cb9-2" title="2"><span class="fl">  formatting rule</span></a></code></pre></div></li>
<li><p>may include sub-items in a similar fashion to titles by:</p>
<ul>
<li><p>indenting sub-items or examples by two spaces per level</p></li>
<li><p>indenting one level at a time</p></li>
<li><p>include examples such as:</p></li>
</ul>
<div class="sourceCode" id="cb10"><pre class="sourceCode markdown"><code class="sourceCode markdown"><a class="sourceLine" id="cb10-1" title="1">- <span class="fl">may include sub-items in a similar fashion to titles by:</span></a>
<a class="sourceLine" id="cb10-2" title="2"></a>
<a class="sourceLine" id="cb10-3" title="3">  - indenting sub-items or examples by three spaces per level</a>
<a class="sourceLine" id="cb10-4" title="4"></a>
<a class="sourceLine" id="cb10-5" title="5">  - indenting one level at a time</a>
<a class="sourceLine" id="cb10-6" title="6"></a>
<a class="sourceLine" id="cb10-7" title="7">  - include examples such as:</a>
<a class="sourceLine" id="cb10-8" title="8"></a>
<a class="sourceLine" id="cb10-9" title="9">  <span class="bn">```markdown</span></a>
<a class="sourceLine" id="cb10-10" title="10"></a>
<a class="sourceLine" id="cb10-11" title="11"><span class="bn">  - may include sub-items in a similar fashion to titles by:</span></a>
<a class="sourceLine" id="cb10-12" title="12"></a>
<a class="sourceLine" id="cb10-13" title="13"><span class="bn">    - indenting sub-items or examples by three spaces per level</span></a>
<a class="sourceLine" id="cb10-14" title="14"></a></code></pre></div></li>
</ul>
<h3 id="inline-code">Inline Code</h3>
<p>Inline code can be included using the single backtick (`) method to produce code-like references. An example of this would be to:</p>
<h6 id="example-6-inline-code">Example 6. Inline Code</h6>
<div class="sourceCode" id="cb11"><pre class="sourceCode markdown"><code class="sourceCode markdown"><a class="sourceLine" id="cb11-1" title="1"></a>
<a class="sourceLine" id="cb11-2" title="2">use the \<span class="bn">`--help\`</span> parameter on the command</a>
<a class="sourceLine" id="cb11-3" title="3"></a></code></pre></div>
<p>Which would produce:</p>
<hr />
<p>use the <code>--help</code> parameter on the command</p>
<hr />
<h3 id="code-blocks">Code Blocks</h3>
<p>All code blocks must be:</p>
<ul>
<li><p>surround by blank lines to separate them from other text</p>
<p><code>MD031 Fenced code blocks should be surrounded by blank lines</code></p></li>
<li><p>fenced with three backticks (```) and not any other code block fencing characters.</p></li>
<li><p>have a language applied to them by entering the name after the three backticks.</p>
<p><code>MD040 Fenced code blocks should have a language specified</code></p></li>
<li><p>an exception to the above text formatting rules as they may contain example lines that are required to be on a single line.</p></li>
</ul>
<p>Where possible, it is advised to try and make use of continuation lines (\) so that these are easily readable on any screen.</p>
<h6 id="example-7-code-block-with-style">Example 7. Code Block with Style</h6>
<div class="sourceCode" id="cb12"><pre class="sourceCode markdown"><code class="sourceCode markdown"><a class="sourceLine" id="cb12-1" title="1"></a>
<a class="sourceLine" id="cb12-2" title="2"><span class="bn">```markdown</span></a>
<a class="sourceLine" id="cb12-3" title="3"><span class="bn">This is a markdown example, &lt;b&gt; will display &lt;b&gt; not start a bold HTML style</span></a>
<a class="sourceLine" id="cb12-4" title="4"><span class="bn">Also ` will actually be displayed not interpreted</span></a></code></pre></div>
<p>The style used on the fenced code block should match the contents of the code block. In the above example, we used <code>markdown</code> as we were displaying a markdown example. The following table is a basic example what is most commonly used in the documentation:</p>
<table>
<thead>
<tr class="header">
<th style="text-align: right;">Type</th>
<th style="text-align: center;">Markdown Language</th>
<th>Usage</th>
</tr>
</thead>
<tbody>
<tr class="odd">
<td style="text-align: right;">C++</td>
<td style="text-align: center;">c++</td>
<td>Formats code block as C++</td>
</tr>
<tr class="even">
<td style="text-align: right;">PHP</td>
<td style="text-align: center;">php</td>
<td>Formats code block as PHP</td>
</tr>
<tr class="odd">
<td style="text-align: right;">SQL</td>
<td style="text-align: center;">sql</td>
<td>Formats code block as SQL</td>
</tr>
<tr class="even">
<td style="text-align: right;">Script</td>
<td style="text-align: center;">bash</td>
<td>Formats code block as bash script</td>
</tr>
<tr class="odd">
<td style="text-align: right;"> </td>
<td style="text-align: center;">sh</td>
<td>Formats code block as posix script</td>
</tr>
<tr class="even">
<td style="text-align: right;">Shell</td>
<td style="text-align: center;">console</td>
<td>Formats code block as command line example</td>
</tr>
<tr class="odd">
<td style="text-align: right;">Markdown</td>
<td style="text-align: center;">markdown</td>
<td>Formats code block as Markdown</td>
</tr>
</tbody>
</table>
<h3 id="urls">URLs</h3>
<p>All URLs should be formatted in the markdown format and not just inserted directly into the text. The format for this is:</p>
<div class="sourceCode" id="cb13"><pre class="sourceCode markdown"><code class="sourceCode markdown"><a class="sourceLine" id="cb13-1" title="1"><span class="ot">[text for link](https://url/wanted)</span></a></code></pre></div>
<p>Failing to do this will result in <code>MD034 Bare URL used</code></p>
<p>This would produce: <a href="https://url/wanted">text for link</a></p>
<h3 id="horizontal-rules">Horizontal Rules</h3>
<p>Horizontal rules should be made using three or more consecutive hyphens on a single line. Again, these should be surrounded by spaces.</p>
<div class="sourceCode" id="cb14"><pre class="sourceCode markdown"><code class="sourceCode markdown"><a class="sourceLine" id="cb14-1" title="1">Paragraph 1 text</a>
<a class="sourceLine" id="cb14-2" title="2"></a>
<a class="sourceLine" id="cb14-3" title="3">---</a>
<a class="sourceLine" id="cb14-4" title="4"></a>
<a class="sourceLine" id="cb14-5" title="5">Paragraph 2 text</a></code></pre></div>
<h2 id="link-new-files-to-readmemd">Link new files to README.md</h2>
<p>Before testing your changes make sure you add the necessary links to README.md for any new files</p>
<p>Running this script will help you check for any missing links.</p>
<pre class="console"><code>bin/check_missing_link.sh
</code></pre>
<h2 id="testing-changes">Testing changes</h2>
<p>To locally test the changes made to any Markdown document, you will need to have ruby installed and then run:</p>
<pre class="console"><code>gem install mdl
</code></pre>
<p>If this pre-requisite has already been completed, then you can simply type the following into your shell</p>
<pre class="console"><code>cd &lt;cacti_docs&gt;
bin/check_markdown_style.sh
</code></pre>
<p>Which will generate the same output that is seen on the Travis CI build status. You should ensure that any reported errors are corrected before submitting your pull request.</p>
<pre class="console"><code>Documentation-Standards.md:221: MD031 Fenced code blocks should be surrounded by blank lines
Documentation-Standards.md:230: MD031 Fenced code blocks should be surrounded by blank lines
Documentation-Standards.md:232: MD031 Fenced code blocks should be surrounded by blank lines
Documentation-Standards.md:265: MD031 Fenced code blocks should be surrounded by blank lines
Documentation-Standards.md:268: MD031 Fenced code blocks should be surrounded by blank lines
Documentation-Standards.md:290: MD031 Fenced code blocks should be surrounded by blank lines
Documentation-Standards.md:292: MD031 Fenced code blocks should be surrounded by blank lines
Documentation-Standards.md:161: MD032 Lists should be surrounded by blank lines
Documentation-Standards.md:250: MD032 Lists should be surrounded by blank lines
Documentation-Standards.md:253: MD032 Lists should be surrounded by blank lines
Documentation-Standards.md:256: MD032 Lists should be surrounded by blank lines
Documentation-Standards.md:236: MD033 Inline HTML
Documentation-Standards.md:240: MD033 Inline HTML
</code></pre>
<hr />
<p><copy>Copyright (c) 2004-2021 The Cacti Group</copy></p>
</body>
</html>
